MemoryNotificationInfo (Java Platform SE 8 )
Keywords: java.lang.management.MemoryNotificationInfo class
Date: 2026-04-24

compact3
java.lang.management

## Class MemoryNotificationInfo

- java.lang.Object
- - java.lang.management.MemoryNotificationInfo

-     public class MemoryNotificationInfo
      extends Object

  The information about a memory notification.

  A memory notification is emitted by `MemoryMXBean` when the Java virtual machine detects that the memory usage of a memory pool is exceeding a threshold value. The notification emitted will contain the memory notification information about the detected condition:

  - The name of the memory pool.
  - The memory usage of the memory pool when the notification was constructed.
  - The number of times that the memory usage has crossed a threshold when the notification was constructed. For usage threshold notifications, this count will be the `usage threshold count`. For collection threshold notifications, this count will be the `collection usage threshold count`.

  A `CompositeData` representing the `MemoryNotificationInfo` object is stored in the `user data` of a `notification`. The `from` method is provided to convert from a `CompositeData` to a `MemoryNotificationInfo` object. For example:

  >           Notification notif;

  >           // receive the notification emitted by MemoryMXBean and set to notif
  >           ...

  >           String notifType = notif.getType();
  >           if (notifType.equals(MemoryNotificationInfo.MEMORY_THRESHOLD_EXCEEDED) ||
  >               notifType.equals(MemoryNotificationInfo.MEMORY_COLLECTION_THRESHOLD_EXCEEDED)) {
  >               // retrieve the memory notification information
  >               CompositeData cd = (CompositeData) notif.getUserData();
  >               MemoryNotificationInfo info = MemoryNotificationInfo.from(cd);
  >               ....
  >           }

  The types of notifications emitted by `MemoryMXBean` are:

  - A `usage threshold exceeded notification`.
    This notification will be emitted when the memory usage of a memory pool is increased and has reached or exceeded its usage threshold value. Subsequent crossing of the usage threshold value does not cause further notification until the memory usage has returned to become less than the usage threshold value.

  - A `collection usage threshold exceeded notification`.
    This notification will be emitted when the memory usage of a memory pool is greater than or equal to its collection usage threshold after the Java virtual machine has expended effort in recycling unused objects in that memory pool.
  Since:
    1.5

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `MEMORY_COLLECTION_THRESHOLD_EXCEEDED` Notification type denoting that the memory usage of a memory pool is greater than or equal to its collection usage threshold after the Java virtual machine has expended effort in recycling unused objects in that memory pool.
    `static String` | `MEMORY_THRESHOLD_EXCEEDED` Notification type denoting that the memory usage of a memory pool has reached or exceeded its usage threshold value.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MemoryNotificationInfo(String poolName, MemoryUsage usage, long count)` Constructs a `MemoryNotificationInfo` object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static MemoryNotificationInfo` | `from(CompositeData cd)` Returns a `MemoryNotificationInfo` object represented by the given `CompositeData`.
    `long` | `getCount()` Returns the number of times that the memory usage has crossed a threshold when the notification was constructed.
    `String` | `getPoolName()` Returns the name of the memory pool that triggers this notification.
    `MemoryUsage` | `getUsage()` Returns the memory usage of the memory pool when this notification was constructed.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### MEMORY_THRESHOLD_EXCEEDED

          public static final String MEMORY_THRESHOLD_EXCEEDED

      Notification type denoting that the memory usage of a memory pool has reached or exceeded its usage threshold value. This notification is emitted by `MemoryMXBean`. Subsequent crossing of the usage threshold value does not cause further notification until the memory usage has returned to become less than the usage threshold value. The value of this notification type is `java.management.memory.threshold.exceeded`.
      See Also:
        Constant Field Values

    - #### MEMORY_COLLECTION_THRESHOLD_EXCEEDED

          public static final String MEMORY_COLLECTION_THRESHOLD_EXCEEDED

      Notification type denoting that the memory usage of a memory pool is greater than or equal to its collection usage threshold after the Java virtual machine has expended effort in recycling unused objects in that memory pool. This notification is emitted by `MemoryMXBean`. The value of this notification type is `java.management.memory.collection.threshold.exceeded`.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### MemoryNotificationInfo

          public MemoryNotificationInfo(String poolName,
                                        MemoryUsage usage,
                                        long count)

      Constructs a `MemoryNotificationInfo` object.
      Parameters:
        `poolName` - The name of the memory pool which triggers this notification.
        `usage` - Memory usage of the memory pool.
        `count` - The threshold crossing count.

  - ### Method Detail

    - #### getPoolName

          public String getPoolName()

      Returns the name of the memory pool that triggers this notification. The memory pool usage has crossed a threshold.
      Returns:
        the name of the memory pool that triggers this notification.

    - #### getUsage

          public MemoryUsage getUsage()

      Returns the memory usage of the memory pool when this notification was constructed.
      Returns:
        the memory usage of the memory pool when this notification was constructed.

    - #### getCount

          public long getCount()

      Returns the number of times that the memory usage has crossed a threshold when the notification was constructed. For usage threshold notifications, this count will be the `threshold count`. For collection threshold notifications, this count will be the `collection usage threshold count`.
      Returns:
        the number of times that the memory usage has crossed a threshold when the notification was constructed.

    - #### from

          public static MemoryNotificationInfo from(CompositeData cd)

      Returns a `MemoryNotificationInfo` object represented by the given `CompositeData`. The given `CompositeData` must contain the following attributes:

      > Attribute Name | Type
      > --- | ---
      > poolName | `java.lang.String`
      > usage | `javax.management.openmbean.CompositeData`
      > count | `java.lang.Long`

      Parameters:
        `cd` - `CompositeData` representing a `MemoryNotificationInfo`
      Returns:
        a `MemoryNotificationInfo` object represented by `cd` if `cd` is not `null`; `null` otherwise.
      Throws:
        `IllegalArgumentException` - if `cd` does not represent a `MemoryNotificationInfo` object.

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.